<?php

class ControllerModuleMostView extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/mostview');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('mostview', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_left'] = $this->language->get('text_left');
		$this->data['text_right'] = $this->language->get('text_right');

		$this->data['entry_limit'] = $this->language->get('entry_limit');
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$this->data['entry_credit'] = $this->language->get('entry_credit');
		$this->data['entry_webboard'] = $this->language->get('entry_webboard');
		$this->data['entry_author'] = $this->language->get('entry_author');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_content_top'] = $this->language->get('text_content_top');
		$this->data['text_content_bottom'] = $this->language->get('text_content_bottom');
		$this->data['text_column_left'] = $this->language->get('text_column_left');
		$this->data['text_column_right'] = $this->language->get('text_column_right');


		$this->data['entry_limit'] = $this->language->get('entry_limit');

		$this->data['entry_layout'] = $this->language->get('entry_layout');
		$this->data['entry_position'] = $this->language->get('entry_position');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['button_add_module'] = $this->language->get('button_add_module');
		$this->data['button_remove'] = $this->language->get('button_remove');

 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		if (isset($this->error['sort_order'])) {
			$this->data['error_sort_order'] = $this->error['sort_order'];
		} else {
			$this->data['error_sort_order'] = '';
		}


		if (isset($this->error['error_show'])) {
			$this->data['error_show'] = $this->error['error_show'];
		} else {
			$this->data['error_show'] = '';
		}

		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/mostview', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
   		);

		$this->data['action'] =$this->url->link('module/mostview', 'token=' . $this->session->data['token'], 'SSL');

		$this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');
/*


		if (isset($this->request->post['mostview_module'])) {
			$modules = explode(',', $this->request->post['mostview_module']);
		} elseif ($this->config->get('mostview_module') != '') {
			$modules = explode(',', $this->config->get('mostview_module'));
		} else {
			$modules = array();
		}
		*/
		$this->data['modules'] = array();

		if (isset($this->request->post['mostview_module'])) {
			$this->data['modules'] = $this->request->post['mostview_module'];
		} elseif ($this->config->get('mostview_module')) {
			$this->data['modules'] = $this->config->get('mostview_module');
		}

		$this->load->model('design/layout');

		$this->data['layouts'] = $this->model_design_layout->getLayouts();

		/*foreach ($modules as $module) {
			if (isset($this->request->post['mostview_' . $module . '_limit'])) {
				$this->data['mostview_' . $module . '_limit'] = $this->request->post['mostview_' . $module . '_limit'];
			} elseif ($this->config->get('mostview_' . $module . '_limit')) {
				$this->data['mostview_' . $module . '_limit'] = $this->config->get('mostview_' . $module . '_limit');
			} else {
				$this->data['mostview_' . $module . '_limit'] = 5;
			}

			if (isset($this->request->post['mostview_' . $module . '_layout_id'])) {
				$this->data['mostview_' . $module . '_layout_id'] = $this->request->post['mostview_' . $module . '_layout_id'];
			} else {
				$this->data['mostview_' . $module . '_layout_id'] = $this->config->get('mostview_' . $module . '_layout_id');
			}

			if (isset($this->request->post['mostview_' . $module . '_position'])) {
				$this->data['mostview_' . $module . '_position'] = $this->request->post['mostview_' . $module . '_position'];
			} else {
				$this->data['mostview_' . $module . '_position'] = $this->config->get('mostview_' . $module . '_position');
			}

			if (isset($this->request->post['mostview_' . $module . '_status'])) {
				$this->data['mostview_' . $module . '_status'] = $this->request->post['mostview_' . $module . '_status'];
			} else {
				$this->data['mostview_' . $module . '_status'] = $this->config->get('mostview_' . $module . '_status');
			}

			if (isset($this->request->post['mostview_' . $module . '_sort_order'])) {
				$this->data['mostview_' . $module . '_sort_order'] = $this->request->post['mostview_' . $module . '_sort_order'];
			} else {
				$this->data['mostview_' . $module . '_sort_order'] = $this->config->get('mostview_' . $module . '_sort_order');
			}
		}

		$this->data['modules'] = $modules;

		if (isset($this->request->post['mostview_module'])) {
			$this->data['mostview_module'] = $this->request->post['mostview_module'];
		} else {
			$this->data['mostview_module'] = $this->config->get('mostview_module');
		}*/

		$this->template = 'module/mostview.tpl';
		$this->children = array(
			'common/header',
			'common/footer',
		);

		$this->response->setOutput($this->render());
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'module/mostview')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		if (isset($this->request->post['mostview_module'])) {
			foreach ($this->request->post['mostview_module'] as $key => $value) {
				if (!$value['limit'] || !$value['limit']) {
					$this->error['error_show'][$key] = $this->language->get('error_show');
				}
				if (!$value['sort_order'] || !$value['sort_order']) {
					$this->error['sort_order'][$key] = $this->language->get('error_sort_order');
				}
			}
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}
?>