<?php

class ControllerModuleMostView extends Controller {
	protected function index($setting) {
		$this->language->load('module/mostview');

      	$this->data['heading_title'] = $this->language->get('heading_title');
      	$this->data['mostview_limit'] = html_entity_decode($this->config->get('mostview_limit'));
      	$this->data['mostview_position'] = html_entity_decode($this->config->get('mostview_position'));

		$this->load->model('catalog/product');
		$this->load->model('catalog/review');

		$this->load->model('tool/image');

		$this->data['products'] = array();

		$results = $this->getMostViewProducts($setting['limit'] );

		foreach ($results as $result) {
			if ($result['image']) {
				$image = $result['image'];
			} else {
				$image = 'no_image.jpg';
			}

			if (($this->config->get('config_customer_price') && $this->customer->isLogged()) || !$this->config->get('config_customer_price')) {
				$price = $this->currency->format($this->tax->calculate($result['price'], $result['tax_class_id'], $this->config->get('config_tax')));
			} else {
				$price = false;
			}

			if ((float)$result['special']) {
				$special = $this->currency->format($this->tax->calculate($result['special'], $result['tax_class_id'], $this->config->get('config_tax')));
			} else {
				$special = false;
			}

			/*if ($this->config->get('config_review_status')) {
				$rating = $result['rating'];
			} else {
				$rating = false;
			}*/

			$this->data['products'][] = array(
				'viewed'    => $result['viewed'],
				'name'    => $this->getNameProducts($result['product_id'],$this->config->get('config_language_id')),
				'price'   => $price,
				'special' => $special,
				'image'   => $this->model_tool_image->resize($image, 150, 150),
				'href'    =>$this->url->link('product/product', 'product_id=' . $result['product_id'])
			);
		}


		if (!$this->config->get('config_customer_price')) {
			$this->data['display_price'] = TRUE;
		} elseif ($this->customer->isLogged()) {
			$this->data['display_price'] = TRUE;
		} else {
			$this->data['display_price'] = FALSE;
		}

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/module/mostview.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/module/mostview.tpl';
		} else {
			$this->template = 'default/template/module/mostview.tpl';
		}


		$this->render();
	}

	public function getMostViewProducts($limit) {
		$query = $this->db->query(" SELECT p.*, ps.price AS special FROM  " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_special  ps ON p.product_id=ps.product_id ORDER BY p.viewed DESC LIMIT ".intval($limit) );
	    return $query->rows;
	}
	public function getNameProducts($id,$lang) {
		$query = $this->db->query(" SELECT * FROM  " . DB_PREFIX . "product_description  WHERE product_id='".(int)$id."' AND language_id ='".$lang."'" );
	    return $query->row['name'];
	}

}
?>